﻿/**
 * Пример: BasicFrame
 * Каркас приложения FreeGlut.
 * Также см. https://bitbucket.org/evetro/av-orchid/wiki/BasicFrame
 */
#include <GL/freeglut.h>

void on_key(unsigned char key, int mouse_x, int mouse_y)
{
  // нажата клавиша с ASCII кодом key, координаты мыши -- mouse_x, mouse_y (в окне)
  switch (key)
  {
  case 27: // ASCII-код esc
    glutLeaveMainLoop(); // покинуть цикл обработки событий
    break;
  // добавьте свои коды клавиш
  default: // остальные коды игнорируются
    return;
  }
}

void repaint()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  // сформировать следующий кадр
  glFinish();
  glutSwapBuffers();
}

void frame_move()
{
  // анимация
  glutPostRedisplay();
}


// прочие обработчики событий (это не все обработчики, доступные для FreeGlut)
// раскомментируйте и заполните нужные,
// удалите остальные

//void on_key_up(unsigned char code, int mouse_x, int mouse_y)
//{
//  // отпущена клавиша с ASCII-кодом code, координаты мыши -- mouse_x, mouse_y (в окне)
//  switch (code)
//  {
//  default:
//    return;
//  }
//}
//
//void on_special_key(int code, int mouse_x, int mouse_y)
//{
//  // нажата "специальная" клавиша, координаты мыши -- mouse_x, mouse_y (в окне)
//  // code может быть следующим
//  // GLUT_KEY_F1, GLUT_KEY_F2, ..., GLUT_KEY_F12 -- функциональные
//  // GLUT_KEY_INSERT
//  // Управление курсором печати:
//  // GLUT_KEY_PAGE_UP, GLUT_KEY_PAGE_DOWN
//  // GLUT_KEY_HOME, GLUT_KEY_END
//  // GLUT_KEY_LEFT, GLUT_KEY_RIGHT, GLUT_KEY_UP, GLUT_KEY_DOWN  (стрелки)
//}
//
//void on_special_key_up(int code, int mouse_x, int mouse_y)
//{
//  // отпущена "специальная" клавиша, координаты мыши -- mouse_x, mouse_y (в окне)
//  // code может быть следующим
//  // GLUT_KEY_F1, GLUT_KEY_F2, ..., GLUT_KEY_F12 -- функциональные
//  // GLUT_KEY_INSERT
//  // Управление курсором печати:
//  // GLUT_KEY_PAGE_UP, GLUT_KEY_PAGE_DOWN
//  // GLUT_KEY_HOME, GLUT_KEY_END
//  // GLUT_KEY_LEFT, GLUT_KEY_RIGHT, GLUT_KEY_UP, GLUT_KEY_DOWN  (стрелки)
//}
//
//void on_reshape(int width, int height)
//{
//  // изменены размеры окна, новые размеры -- width, height
//  glViewport(0, 0, width, height);
//}
//
//void on_visibility_change(int status)
//{
//  switch (status)
//  {
//  case GLUT_FULLY_COVERED: // окно полностью закрыто другими окнами
//  case GLUT_HIDDEN: // окно "скрыто" (обычно означает, что окно свёрнуто)
//    break;
//  case GLUT_FULLY_RETAINED: // окно полностью видимо
//  case GLUT_PARTIALLY_RETAINED: // окно частично перекрыто другими окнами
//    break;
//  default:
//    return;
//  }
//}
//
//void on_mouse_entry(int status)
//{
//  if (status == GLUT_ENTERED)
//  {
//    // указатель мыши зашёл в окно
//  }
//  else // status == GLUT_LEFT
//  {
//    // указатель мыши покинул окно
//  }
//}
//
//void on_hover(int mouse_x, int mouse_y)
//{
//  // мышь двигается (кнопки отпущены) в окне,
//  // текущие координаты -- mouse_x, mouse_y
//}
//
//void on_drag(int mouse_x, int mouse_y)
//{
//  // мышь двигается (какие-то кнопки зажаты) в окне, 
//  // текущие координаты -- mouse_x, mouse_y
//}
//
//void on_mouse_button(int button, int state, int x, int y)
//{
//  // x, y -- координаты мыши на момент события
//  if (state == GLUT_DOWN)
//  {
//    // кнопка мыши нажата
//    switch (button)
//    {
//    case GLUT_LEFT_BUTTON: // это -- левая кнопка
//      break;
//    case GLUT_RIGHT_BUTTON: // это -- правая кнопка
//      break;
//    case GLUT_MIDDLE_BUTTON: // это -- средняя кнопка
//    default:
//      return;
//    }
//  }
//  else // state == GLUT_UP
//  {
//    // кнопка мыши отпущена
//    switch (button)
//    {
//    case GLUT_LEFT_BUTTON: // это -- левая кнопка
//      break;
//    case GLUT_RIGHT_BUTTON: // это -- правая кнопка
//      break;
//    case GLUT_MIDDLE_BUTTON: // это -- средняя кнопка
//    default:
//      return;
//    }
//  }
//}
//
//void on_mouse_wheel(int wheel, int direction, int x, int y)
//{
//  // прокрутка колёсика (если не зарегистрирован, может сообщать как нажатие средней кнопки)
//  // wheel -- номер колёсика,
//  // direction -- +1 или -1 (направление прокрутки),
//  // x, y -- координаты мыши
//}


int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  // двойная буферизация и полноэкранное сглаживание методом MSAA (количество сэмплов по умолчанию)
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_MULTISAMPLE);
  
  // стартовое положение, размеры и заголовок окна
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(800, 560);
  glutCreateWindow("BasicFrame");
  
  // здесь можно разместить общие настройки OpenGL

  // зарегистрировать обработчики событий
  glutIdleFunc(frame_move);
  glutDisplayFunc(repaint);
  glutKeyboardFunc(on_key);

  // раскомментируйте нужные
  //glutKeyboardUpFunc(on_key_up);
  //glutSpecialFunc(on_special_key);
  //glutSpecialUpFunc(on_special_key_up);

  //glutReshapeFunc(on_reshape);
  //glutWindowStatusFunc(on_visibility_change);
  //  
  //glutEntryFunc(on_mouse_entry);
  //glutPassiveMotionFunc(on_hover);
  //glutMotionFunc(on_drag);
  //glutMouseFunc(on_mouse_button);
  //glutMouseWheelFunc(on_mouse_wheel);

  // войти в цикл обработки событий
  glutMainLoop();
  return 0;
}
